/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.system.custommenu.service.impl;

import org.apache.commons.lang.StringUtils;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.secure.BladeUser;
import org.springblade.core.tool.node.INode;
import org.springblade.modules.system.vo.MenuVO;
import org.springblade.system.custommenu.entity.CustomMenu;
import org.springblade.system.custommenu.vo.CustomMenuVO;
import org.springblade.system.custommenu.mapper.CustomMenuMapper;
import org.springblade.system.custommenu.service.ICustomMenuService;
import org.springblade.core.mp.base.BaseServiceImpl;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.metadata.IPage;

import java.util.ArrayList;
import java.util.List;

/**
 *  服务实现类
 *
 * @author BladeX
 * @since 2020-11-29
 */
@Service
public class CustomMenuServiceImpl extends BaseServiceImpl<CustomMenuMapper, CustomMenu> implements ICustomMenuService {

	@Override
	public IPage<CustomMenuVO> selectCustomMenuPage(IPage<CustomMenuVO> page, CustomMenuVO customMenu) {
		return page.setRecords(baseMapper.selectCustomMenuPage(page, customMenu));
	}

	@Override
	public List<CustomMenuVO> getAllList() {
		return baseMapper.getAllList();
	}

	@Override
	public List<CustomMenuVO> getByParentId(Long parentId) {
		return baseMapper.getByParentId(parentId);
	}

	@Override
	public void recoverWithCustomMenu(List<MenuVO> list, BladeUser user) {
		list.forEach(item -> {
			CustomMenuVO customMenu = new CustomMenuVO();
			customMenu.setMenuId(item.getId());
			customMenu.setTenantId(user.getTenantId());
			CustomMenu one = this.getOne(Condition.getQueryWrapper(customMenu));
			if (one != null && StringUtils.isNotBlank(one.getMenuName())){
				item.setName(one.getMenuName());
			}
			List<INode> children = item.getChildren();
			List<MenuVO> child = new ArrayList<>();
			children.forEach(it -> {
				child.add((MenuVO) it);
			});

			if (children != null && children.size() > 0){
				recoverWithCustomMenu(child, user);
			}
		});
	}

}
